﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using shuzihuarongdao;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace shuzihuarongdao.Tests
{
    [TestClass()]
    public class BoardTests
    {
        [TestMethod()]
        public void BlockCanMoveTest()
        {
            Board b = new Board();
            Assert.IsFalse(b.BlockCanMove(0));
            Assert.IsFalse(b.BlockCanMove(1));
            Assert.IsFalse(b.BlockCanMove(2));
            Assert.IsFalse(b.BlockCanMove(3));
            Assert.IsFalse(b.BlockCanMove(4));
            Assert.IsFalse(b.BlockCanMove(7));
            Assert.IsFalse(b.BlockCanMove(8));
            Assert.IsFalse(b.BlockCanMove(9));
            Assert.IsFalse(b.BlockCanMove(10));
            Assert.IsTrue(b.BlockCanMove(11));
            Assert.IsTrue(b.BlockCanMove(14));
        }

        [TestMethod()]
        public void MoveBlockTest()
        {
            Board b = new Board();
            Assert.AreEqual(15, b.GetEmptyBlockPosition());

            b.MoveBlock(11);
            Assert.AreEqual(11, b.GetEmptyBlockPosition());

            Assert.IsTrue(b.BlockCanMove(7));
            Assert.IsTrue(b.BlockCanMove(10));
            Assert.IsTrue(b.BlockCanMove(15));

            Assert.IsFalse(b.BlockCanMove(11));
            Assert.IsFalse(b.BlockCanMove(14));

            b.MoveBlock(7);
            Assert.AreEqual(7, b.GetEmptyBlockPosition());

            Assert.IsTrue(b.BlockCanMove(3));
            Assert.IsTrue(b.BlockCanMove(6));
            Assert.IsTrue(b.BlockCanMove(8));
            Assert.IsTrue(b.BlockCanMove(11));
        }

        [TestMethod()]
        public void GenerateBoardTest()
        {
            Board b1 = new Board();
            Assert.IsTrue(b1.IsValid());
            Board b2 = Board.GenerateBoard(DifficultyLevel.EASY);
            Assert.IsTrue(b2.IsValid());
        }

        [TestMethod()]
        public void IsSolvedTest()
        {
            Board b = new Board();
            Assert.IsTrue(b.IsSolved());
            b.MoveBlock(11);
            Assert.IsFalse(b.IsSolved());
            b.MoveBlock(15);
            Assert.IsTrue(b.IsSolved());
        }
    }
}